//+------------------------------------------------------------------+
//|                                        Simple MTF Stochastic.mq4 |
//|                           (c) Airquest, based on Tomcat98's idea |
//|                                             airquest@hotmail.com |
//+------------------------------------------------------------------+

#property indicator_separate_window
#property indicator_buffers 6

#property indicator_color1 Yellow
#property indicator_color2 Red
#property indicator_color3 DodgerBlue
#property indicator_color4 Red
#property indicator_color5 Blue
#property indicator_color6 Red
#property indicator_level1     20.0
#property indicator_level2     80.0

extern int TimeFrame1 =PERIOD_CURRENT;
extern bool ShowTF1   =True;
extern bool ShowSignal1 =True;
extern int TimeFrame2 =PERIOD_H4;
extern bool ShowTF2   =True;
extern bool ShowSignal2 =True;
extern int TimeFrame3 =PERIOD_D1;
extern bool ShowTF3   =True;
extern bool ShowSignal3 =True;
extern int StoPeriod1 =14;
extern int StoPeriod2 =14;
extern int StoPeriod3 =14;
extern int StoSignal1 =3;
extern int StoSignal2 =3;
extern int StoSignal3 =3;
extern int StoSlowing1 =3;
extern int StoSlowing2 =3;
extern int StoSlowing3 =3;
extern int MAMethod1  =MODE_SMA;
extern int MAMethod2  =MODE_SMA;
extern int MAMethod3  =MODE_SMA;
extern int Price1     =STO_LOWHIGH;
extern int Price2     =STO_LOWHIGH;
extern int Price3     =STO_LOWHIGH;
extern int Shift1     =0;
extern int Shift2     =0;
extern int Shift3     =0;
extern int CountBars1 =500;
extern int CountBars2 =500;
extern int CountBars3 =500;
extern int x_prd      =0;

//---- buffers
double Multi_Indic[];
double Multi_Indic_Signal[];
double Multi_Indic1[];
double Multi_Indic1_Signal[];
double Multi_Indic2[];
double Multi_Indic2_Signal[];

string short_name;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
{

//---- name for DataWindow and indicator subwindow label 
    short_name = "Simple MTF Stochastic - "+TimeFrame1+"("+StoPeriod1+","+StoSignal1+","+StoSlowing1+"),"+TimeFrame2+"("+StoPeriod2+","+StoSignal2+","+StoSlowing2+"),"+TimeFrame3+"("+StoPeriod3+","+StoSignal3+","+StoSlowing3+")";
    IndicatorShortName(short_name);
    IndicatorBuffers(6);
    SetIndexBuffer(0,Multi_Indic);
    SetIndexBuffer(1,Multi_Indic_Signal);
    if (ShowTF1) 
    {
    SetIndexStyle(0,DRAW_LINE);
    if (ShowSignal1)SetIndexStyle(1,DRAW_LINE);else SetIndexStyle(1,DRAW_NONE);
    }
    else
    {
    SetIndexStyle(0,DRAW_NONE);
    SetIndexStyle(1,DRAW_NONE);
    }
    
    SetIndexBuffer(2,Multi_Indic1);
    SetIndexBuffer(3,Multi_Indic1_Signal);
    if (ShowTF2) 
    {
    SetIndexStyle(2,DRAW_LINE);
    if (ShowSignal2)SetIndexStyle(3,DRAW_LINE);else SetIndexStyle(3,DRAW_NONE);
    }
    else
    {
    SetIndexStyle(2,DRAW_NONE);
    SetIndexStyle(3,DRAW_NONE);
    }
     
    SetIndexBuffer(4,Multi_Indic2);
    SetIndexBuffer(5,Multi_Indic2_Signal);
    if (ShowTF3) 
    {
    SetIndexStyle(4,DRAW_LINE);
    if (ShowSignal3)SetIndexStyle(5,DRAW_LINE);else SetIndexStyle(5,DRAW_NONE);
    }
    else
    {
    SetIndexStyle(4,DRAW_NONE);
    SetIndexStyle(5,DRAW_NONE);
    }
    
    SetIndexShift(0,Shift1);
    SetIndexShift(1,Shift1);
    SetIndexShift(2,Shift2);
    SetIndexShift(3,Shift2);
    SetIndexShift(4,Shift3);
    SetIndexShift(5,Shift3);

//----
   return (0);
}
int deinit()
{
   return (0);
}

//+------------------------------------------------------------------+
//| Skid                                                           |
//+------------------------------------------------------------------+

int start()
  {
   if (CountBars1>=Bars) CountBars1=Bars;
   SetIndexDrawBegin(0,Bars-CountBars1);
   SetIndexDrawBegin(1,Bars-CountBars1);
   SetIndexDrawBegin(2,Bars-CountBars2);
   SetIndexDrawBegin(3,Bars-CountBars2);
   SetIndexDrawBegin(4,Bars-CountBars3);
   SetIndexDrawBegin(5,Bars-CountBars3);

   int i, ii,iii, counted_bars=IndicatorCounted();

   double t_prd;

//----
   if(Bars<=x_prd) return(0);

//---- initial zero
   if(counted_bars<x_prd)
   {
      for(i=1;i<=x_prd;i++) Multi_Indic[CountBars1-i]=0.0;
      for(i=1;i<=x_prd;i++) Multi_Indic_Signal[CountBars1-i]=0.0;
      for(ii=1;ii<=x_prd;ii++) Multi_Indic1[CountBars1-ii]=0.0;
      for(ii=1;ii<=x_prd;ii++) Multi_Indic1_Signal[CountBars1-ii]=0.0;
      for(iii=1;iii<=x_prd;iii++) Multi_Indic2[CountBars1-iii]=0.0;
      for(iii=1;iii<=x_prd;iii++) Multi_Indic2_Signal[CountBars1-iii]=0.0;
   }

//----
   i=CountBars1-x_prd-1;
   ii=CountBars1-x_prd-1;
   iii=CountBars1-x_prd-1;

   t_prd=x_prd/2+1;

   while(i>=0)
   while(ii>=0)
   while(iii>=0)
     {
     Multi_Indic[i]=(iStochastic(NULL,TimeFrame1,StoPeriod1,StoSignal1,StoSlowing1,MAMethod1,Price1,0,i));
     Multi_Indic_Signal[i]=(iStochastic(NULL,TimeFrame1,StoPeriod1,StoSignal1,StoSlowing1,MAMethod1,Price1,1,i));
     Multi_Indic1[ii]=(iStochastic(NULL,TimeFrame2,StoPeriod2,StoSignal2,StoSlowing2,MAMethod2,Price2,0,ii));
     Multi_Indic1_Signal[ii]=(iStochastic(NULL,TimeFrame2,StoPeriod2,StoSignal2,StoSlowing2,MAMethod2,Price2,1,ii));
     Multi_Indic2[iii]=(iStochastic(NULL,TimeFrame3,StoPeriod3,StoSignal3,StoSlowing3,MAMethod3,Price3,0,iii));
     Multi_Indic2_Signal[iii]=(iStochastic(NULL,TimeFrame3,StoPeriod3,StoSignal3,StoSlowing3,MAMethod3,Price3,1,iii));
      i--;
      ii--;
      iii--;
     }
   return(0);
  }
  
//+------------------------------------------------------------------+